#if !defined(_AUTOPOLY_H_)
#define _AUTOPOLY_H_

#include <afxcoll.h>

class CCoord
{
private:
	double m_X;
	double m_Y;
	int m_Flag;

public:
	__declspec(dllexport)	CCoord(double x=0.0,double y=0.0,int flag=0);
	__declspec(dllexport)	CCoord(const CCoord& data);
	__declspec(dllexport)	const CCoord& operator=(const CCoord& data);
	__declspec(dllexport)	double X(void);
	__declspec(dllexport)	double Y(void);
	__declspec(dllexport)	int Flag(void);
};

class CAutoPolygonElement
{
private:
	double m_Sx;
	double m_Sy;
	double m_Ex;
	double m_Ey;
	int m_Key1;
	int m_Key2;
	int m_Unique;

public:
	__declspec(dllexport)	CAutoPolygonElement(double sx=0.0,double sy=0.0,double ex=0.0,double ey=0.0,int key1=0,int key2=0);
	__declspec(dllexport)	CAutoPolygonElement(const CAutoPolygonElement& data);
	__declspec(dllexport)	const CAutoPolygonElement& operator=(const CAutoPolygonElement& data);
	__declspec(dllexport)	double Sx(void);
	__declspec(dllexport)	double Sy(void);
	__declspec(dllexport)	double Ex(void);
	__declspec(dllexport)	double Ey(void);
	__declspec(dllexport)	int Key1(void);
	__declspec(dllexport)	int Key2(void);
};

class COutputAutoPolygon
{
private:
	CPtrList m_Element;
	bool m_Critical;
	bool m_Cross;
	bool m_Return;
	CPtrList m_Error;

public:
	__declspec(dllexport)	COutputAutoPolygon();
	__declspec(dllexport)	~COutputAutoPolygon();
	__declspec(dllexport)	CPtrList& Element(void);
	__declspec(dllexport)	int Count(void);
	__declspec(dllexport)	int Round(void);
	__declspec(dllexport)	CPtrList& Error(void);
	__declspec(dllexport)	bool Critical(void);
	__declspec(dllexport)	bool Cross(void);
	__declspec(dllexport)	bool Return(void);
	__declspec(dllexport)	void RemoveReturnLine(void);
};

class CAutoPolygon
{
private:
	CPtrList m_Element;
	CPtrList m_Polygon;

public:
	__declspec(dllexport)	~CAutoPolygon();
	__declspec(dllexport)	CAutoPolygonElement* Entry(CAutoPolygonElement& data);
	__declspec(dllexport)	CPtrList& Polygon(void);
	__declspec(dllexport)	int MakingPolygon(void);
	__declspec(dllexport)	void RemoveElement(void);
	__declspec(dllexport)	void InsertCrossPoint(void);
	__declspec(dllexport)	void AddFrameLine(double minx,double miny,double maxx,double maxy,int k1=0,int k2=0);
	__declspec(dllexport)	bool restriction();
};

#endif // !defined(_AUTOPOLY_H_)
